#ifndef RATIO_H
#define RATIO_H

double MCMCratio(int **graphnew, double **betanew, int **graphold, double **betaold, int **z, int index1, int index2, int **graphprior,   int &Nnode, int &Nsample, double &pho)
{
	int i,j;
	int count1, count2, count3, count4;
	double ratio, tmp1, tmp2, tmp3;
	double *v;
	
	
	//Initialize
	v = new double[Nnode];
	
	for (j=0; j<Nnode; j++)
		v[j] = 1/(1+exp(-betaold[j][j]));
	
	tmp1 = 0.0;
	for (i=0;i<Nsample;i++)
	{
		tmp1 = tmp1 + (z[index1][i]-v[index1]) * (z[index2][i]-v[index2]);
	}
	
	count1 = 0;
	count2 = 0;
	count3 = 0;
	count4 = 0;
	for (i=0; i<Nnode; i++)
	{
		for (j=(i+1); j<Nnode; j++)
		{
			if (graphprior[i][j]==0 & graphold[i][j]==1) count1 = count1 + 1; //in prior, not in old
			if (graphprior[i][j]==0 & graphnew[i][j]==1) count2 = count2 + 1; //in prior, not in new
			if (graphprior[i][j]==1 & graphold[i][j]==0) count3 = count3 + 1;
			if (graphprior[i][j]==1 & graphnew[i][j]==0) count4 = count4 + 1;
		}
	}
	
	tmp2 = betaold[index1][index2] * tmp1 + Nsample * log(1/NConstant(betaold, Nnode)) + log(pho) * (count1 + count3);
	
	tmp3 = betanew[index1][index2] * tmp1 + Nsample * log(1/NConstant(betanew, Nnode)) + log(pho) * (count2 + count4);
	
	if (graphnew[index1][index2] == 0)
	{
		tmp2 = tmp2 + log(dnorm(betaold[index1][index2], 0, sigma_beta, 0));
		tmp3 = tmp3 + log(dnorm(betaold[index1][index2], 0, sigma_betapro, 0));
	} else {
		tmp2 = tmp2 + log(dnorm(betanew[index1][index2], 0, sigma_betapro,0));
		tmp3 = tmp3 + log(dnorm(betanew[index1][index2], 0, sigma_beta,0));
	}
	
	ratio = exp(tmp3 - tmp2);
	if (ratio>1) ratio = 1;
	
	delete[] v; v = NULL;
	return(ratio);
	
	
}
#endif
