#ifndef NC_H
#define NC_H

const double sigma_betapro = 0.4;
const double sigma_beta = pow(10,0.5);
const double gamma_kplus = 10;
const double gamma_kminus = 10;
const double lambda_kplus = 50;
const double lambda_kminus = 50;
const double theta_mu = 0;
const double tau_mu = 1;
const double gamma_sigma = 2;
const double lambda_sigma = 0.1;
//const double pho = 0.9;

double NConstant(double **beta, int &Nnode)
{
	int i, j, k,tmp;
	double *v;
	double *prob;
	double sum_prob = 0.0;
	double tmp_prob = 0.0;
	int num = pow(2,Nnode);
	
	int combina[Nnode][num];
	
	for (i=0;i<Nnode;i++)
	{
		for (j=0;j<num;j++)
		{
			tmp = j/pow(2,Nnode-1-i);
			if (tmp%2==0) combina[i][j] = 0;
			else combina[i][j] = 1;
		}
	}
	v = new double[Nnode];
	prob = new double[num];
	
	
	//compute the diagnoal 		
	for (i=0; i<Nnode; i++)
		v[i] = 1/(1+exp(-beta[i][i]));
	
	for (i=0; i<num; i++)
	{
		tmp_prob = 0.0;
		for (j=0; j<Nnode; j++)
			tmp_prob = tmp_prob + beta[j][j]*combina[j][i];
		for (j=0; j<(Nnode-1);j++)
			for (k=(j+1); k<Nnode; k++)
				tmp_prob = tmp_prob + beta[j][k]*(combina[j][i]-v[j])*(combina[k][i]-v[k]);
		prob[i] = exp(tmp_prob);
		sum_prob = sum_prob + prob[i];
	}
	
	//Delete the memory 
	delete[] prob; prob = NULL;
	delete[] v; v = NULL;
	return(sum_prob);
}

#endif
