library(network)

pdf('../paper/plot/compare_node41.pdf')
set.seed(19850116)
node4_comp = network.initialize(4, directed=FALSE)
add.edges(node4_comp,c(1,1,2,3),c(2,3,4,4) )
plot(node4_comp, label=c("1","2","3","4"),edge.col=1,edge.label=c("2.96","4.07","3.30","4.46"))
title(main="Simulation Truth")
dev.off()

pdf('../paper/plot/compare_node42.pdf')
set.seed(19850116)
node4_comp = network.initialize(4, directed=FALSE)
add.edges(node4_comp,c(1,1,2,3),c(2,3,4,4) )
plot(node4_comp, label=c("1","2","3","4"),edge.col=1,edge.label=c("3.34","3.56","2.82","5.27"))
title(main="Posterior Estimation")
dev.off()

pdf('../paper/plot/compare_node51.pdf')
set.seed(19850116)
node5_comp = network.initialize(5, directed=FALSE)
add.edges(node5_comp,c(1,1,2,3,3),c(2,5,4,4,5) )
plot(node5_comp, label=c("1","2","3","4","5"),edge.col=1,edge.label=c("3.38","3.00","3.92","4.21","3.73"))
title(main="Simulation Truth")
dev.off()

pdf('../paper/plot/compare_node52.pdf')
set.seed(19850116)
node5_comp = network.initialize(5, directed=FALSE)
add.edges(node5_comp,c(1,1,2,3,3),c(2,5,4,4,5) )
plot(node5_comp, label=c("1","2","3","4","5"),edge.col=1,edge.label=c("3.48","3.00","3.00","4.25","4.41"))
title(main="Posterior Estimation")
dev.off()

pdf('../paper/plot/compare_node61.pdf')
set.seed(19850116)
node6_comp = network.initialize(6, directed=FALSE)
add.edges(node6_comp,c(1,2,2,2,4,5),c(5,3,5,6,5,6))
plot(node6_comp, label=c("1","2","3","4","5","6"),edge.col=c(2,2,1,1,2,1),edge.label=c("-3.71","-4.37","3.90","3.46","-3.90","3.66"))
title(main="Simulation Truth")
dev.off()
pdf('../paper/plot/compare_node62.pdf')
set.seed(19850116)
node6_comp = network.initialize(6, directed=FALSE)
add.edges(node6_comp,c(1,2,2,2,4,5),c(5,3,5,6,5,6))
plot(node6_comp, label=c("1","2","3","4","5","6"),edge.col=c(2,2,1,1,2,1),edge.label=c("-3.18","-4.05","4.98","3.29","-3.73","4.92"))
title(main="Posterior Estimation")
dev.off()

library(ppcor)
load("Real_BRCA.RData")
set.seed(-1)
rowNames = paste(data_BRCA[,1],"_",data_BRCA[,2],sep="")
pdf("../paper/plot/brca.pdf",width=10)
beta = Result$post.mean.beta
par(oma=c(0,5,0,5))
par(mgp=c(0,1,0))
g = network.initialize(8, directed=FALSE)
a=Result$graphMatrixList$`Frequency 0.0057`
diag(a)=0
g=network(a,directed=FALSE)
beta1 = beta[upper.tri(beta)][which(a[upper.tri(a)]==1)]
plot(g, label=rowNames,edge.col=(beta<0)+1)
dev.off()


set.seed(19890104)
rowNames = paste(data_HNSC[,1],"_",data_HNSC[,2],sep="")
pdf("../paper/plot/HNSC.pdf",width=10)
load("Real_HNSC.RData")
beta = Result$post.mean.beta
par(oma=c(0,5,0,5))
par(mgp=c(0,1,0))
g = network.initialize(8, directed=FALSE)
a=Result$graphMatrixList$`Frequency 0.0029`
diag(a)=0
g=network(a,directed=FALSE)
beta1 = beta[upper.tri(beta)][which(a[upper.tri(a)]==1)]
plot(g, label=rowNames,edge.col=(beta<0)+1)
dev.off()

#########################Real 1
data1 = read.table("../GE-ME-CN Data/BRCA_mTOR_signaling_pathwayData.txt",header=T)
id1 = which(data1[,1]=="PTEN")
id2 = which(data1[,1]=="INS")
id3 = which(data1[,1]=="MAPK3")
load("BRCA_mTOR.RData")
set.seed(19890104)
rowNames = paste(data1[c(id1,id2,id3),1],"_",data1[c(id1,id2,id3),2],sep="")
pdf("../paper/plot/BRCA_mTOR.pdf",width=10)
par(oma=c(0,5,0,5))
par(mgp=c(0,1,0))
a=Result$graphMatrixList$`Frequency 0.005`
beta = Result$post.mean.beta
diag(a)=0
g=network(a,directed=FALSE)
beta1 = beta[upper.tri(beta)][which(a[upper.tri(a)]==1)]
plot(g, label=rowNames,edge.col=(beta<0)+1,edge.label=round(beta,2))
dev.off()

##############real2
data2 = read.table("../GE-ME-CN Data/BRCA_p53_signaling_pathwayData.txt",header=T)
id1 = which(data2[,1]=="ATM")
id2 = which(data2[,1]=="TP53")
id3 = which(data2[,1]=="TSC2")
load("BRCA_p53.RData")
set.seed(19890104)
rowNames = paste(data2[c(id1,id2,id3),1],"_",data2[c(id1,id2,id3),2],sep="")
pdf("../paper/plot/BRCA_p53.pdf",width=10)
par(oma=c(0,5,0,5))
par(mgp=c(0,1,0))
a=Result$graphMatrixList$`Frequency 0.0064`
beta = Result$post.mean.beta
diag(a)=0
g=network(a,directed=FALSE)
beta1 = beta[upper.tri(beta)][which(a[upper.tri(a)]==1)]
plot(g, label=rowNames,edge.col=(beta<0)+1, edge.label=round(beta,2))
dev.off()


