#ifndef BETA_H
#define BETA_H
void update_beta(double **betaold, double **betanew, int **z, int **graph, int &Nnode, int &Nsample)
{
	int i,j,k,s;
	double u, ratio, tmp1, tmp2, tmp3;
	double sum_prob = 0.0;
	double *vold;
	double *vnew;
	
	
	//Initialize
	vold = new double[Nnode];
	vnew = new double[Nnode];

	for (i=0; i<Nnode; i++)
		for (j=0; j<Nnode; j++)
			betanew[i][j]=betaold[i][j];	
	
	//Update the beta on diagnal
	for (i=0; i<Nnode; i++)
	{
		for (j=0; j<Nnode; j++)
			for (k=0; k<Nnode; k++)
				betaold[j][k]=betanew[j][k];
		betanew[i][i] = rnorm(betaold[i][i], sigma_betapro);  //the new beta
			u = runif(0,1);
		for (j=0; j<Nnode; j++)
		{
			vold[j] = 1/(1+exp(-betaold[j][j]));
			vnew[j] = 1/(1+exp(-betanew[j][j]));
		}
			
		tmp1 = 0.0;
		for (j=0;j<Nsample;j++)
		{
			tmp1 = tmp1 + z[i][j];
		}
		tmp2 = 0.0;
		for (j=0; j<Nnode;j++)
		{
			if (j!=i)
			{
				tmp3 = 0.0;
				for (k=0; k<Nsample; k++)
					tmp3 += z[j][k] - vold[j];
				tmp2 += betaold[i][j]*(vold[i]-vnew[i])*tmp3;
			}
		}

		ratio = exp( pow(betaold[i][i],2)/(2*pow(sigma_beta,2)) - pow(betanew[i][i],2)/(2*pow(sigma_beta,2)) - (betaold[i][i]-betanew[i][i])*tmp1 + tmp2 + Nsample*log(NConstant(betaold, Nnode)/NConstant(betanew, Nnode))     );
		if (ratio>1) ratio = 1;
		u = runif(0,1);
		if (u>ratio) betanew[i][i] = betaold[i][i];
	}
	
	//Update the 2-way interaction effect beta
	for (i=0; i<Nnode; i++)
		vnew[i] = 1/(1+exp(-betanew[i][i]));
	for (i=0;i<(Nnode-1);i++)
	{
		for (j=(i+1); j<Nnode; j++)
		{
			if (graph[i][j]==0)
			{
				betanew[i][j] = 0;
				betanew[j][i] = 0;
			}
			else {
				for (s=0; s<Nnode; s++)
					for (k=0; k<Nnode; k++)
						betaold[s][k]=betanew[s][k];
				betanew[i][j] = rnorm(betaold[i][j], sigma_betapro);
				betanew[j][i] = betanew[i][j];
				tmp1 = 0.0;
				for (k=0; k<Nsample; k++)
					tmp1 += (z[i][k]-vnew[i])*(z[j][k]-vnew[j]);
				
				ratio = exp( pow(betaold[i][j],2)/(2*pow(sigma_beta,2)) - pow(betanew[i][j],2)/(2*pow(sigma_beta,2)) - (betaold[i][j]-betanew[i][j])*tmp1 + Nsample*log(NConstant(betaold, Nnode)/NConstant(betanew, Nnode))     );
				if (ratio>1) ratio = 1;
                u = runif(0,1);
				if (u>ratio) 
				{
					betanew[i][j] = betaold[i][j];
					betanew[j][i] = betaold[i][j];
				}
			}
		}
	}

	//Delete Memory
	delete[] vnew; vnew = NULL;
	delete[] vold; vold = NULL;
}


#endif
