#ifndef GRAPH_H
#define GRAPH_H
#include <algorithm>
#include <ctime>
#include <iostream>
#include <vector>
using namespace std;

void update_graph(int **z, int **graphold, int **graphnew, double **beta, int *graphpriorvector,  int &Nnode, int &Nsample, double &pho)
{
  double u, ratio, tmp1, tmp2, tmp3, temp_ratio;
	double **betaold;
	int **graphprior;
        int i,j,k,s, index1, index2;
	betaold = new double* [Nnode];
	graphprior = new int* [Nnode];
	for (i=0; i<Nnode; i++)
	{
		betaold[i] = new double[Nnode];
		graphprior[i] = new int[Nnode];
	}

        vector<int> randvector;

  // Initialize:
  for (i=0; i<Nnode; i++)
    {
      for (j=0; j<Nnode; j++)
	{
	  betaold[i][j]=beta[i][j];
	  graphnew[i][j]=graphold[i][j];
	  graphprior[i][j]=graphpriorvector[Nnode*j+i];
	}
    }

  /***** Amounts to about 600 extra while-loops calculating a new random number for 10,000 iterations.  
         Looking to decrease the looping with random_shuffle but nothing appreciably faster so far:
  index1 = rand()%Nnode;
  index2 = rand()%Nnode;
  while (index2==index1) index2 = rand()%Nnode;
  cout << index1 << " " << index2;
  *****/

  for (int l=0; l<Nnode; l++) 
    randvector.push_back(l);  
  random_shuffle(randvector.begin(), randvector.end());
  index1 = randvector[0];
  index2 = randvector[1];

  if (graphold[index1][index2] ==1)
    {
      graphnew[index1][index2] = 0;
      graphnew[index2][index1] = 0;
      beta[index1][index2] = 0;
      beta[index2][index1] = 0;
      temp_ratio = MCMCratio(graphnew, beta, graphold, betaold, z, index1, index2, graphprior, Nnode, Nsample, pho);
      u = runif(0,1);
      if (u>temp_ratio)
	{
	  beta[index1][index2] = betaold[index1][index2];
	  beta[index2][index1] = beta[index1][index2];
	  graphnew[index1][index2] = graphold[index1][index2];
	  graphnew[index2][index1] = graphnew[index1][index2];
	} 
    } 
  else 
    {
      graphnew[index1][index2] = 1;
      graphnew[index2][index1] = 1;
      beta[index1][index2] = rnorm(0, sigma_betapro);
      beta[index2][index1] = beta[index1][index2];
      temp_ratio = MCMCratio(graphnew, beta, graphold, betaold, z, index1, index2, graphprior, Nnode, Nsample, pho);
      u = runif(0,1);
      if (u>temp_ratio)
	{
	  beta[index1][index2] = betaold[index1][index2];
	  beta[index2][index1] = beta[index1][index2];
	  graphnew[index1][index2] = graphold[index1][index2];
	  graphnew[index2][index1] = graphnew[index1][index2];
	}
    } 
	for (i=0; i<Nnode; i++)
	{
		delete[] graphprior[i]; graphprior[i]=NULL;
		delete[] betaold[i]; betaold[i]=NULL;
	}
	delete[] graphprior; graphprior = NULL;
	delete[] betaold; betaold = NULL;
}

#endif
