#ifndef KMINUS_H
#define KMINUS_H

void update_kminus(double **y, double *mu, int **e, double *kminus, int &Nnode, int &Nsample)
{

  int i,j, count1;
  double lower_kminus_new, upper_kminus_new, gamma_kminus_new, x_kminus, b1;
  
  for (i=0; i<Nnode; i++)
    {
      b1 = R_NegInf;
      count1 = 0;
      for (j=0; j<Nsample; j++)
	{
	  if (e[i][j]==-1)
	    {
	      count1++;
	      if ((mu[i]-y[i][j])>b1) 
		b1 = mu[i]-y[i][j];
	    }
	}
      if (b1 < 0) 
	b1 = 0;
      lower_kminus_new = R_NegInf;
      upper_kminus_new = (b1 > 0) ? 1.0/b1 : R_PosInf;
      gamma_kminus_new = gamma_kminus + count1;
      x_kminus = qgamma( runif(0, pgamma(upper_kminus_new, gamma_kminus_new, 1.0/lambda_kminus, 1, 0) ), gamma_kminus_new, 1.0/lambda_kminus, 1, 0 );
		if (x_kminus!=0)
		{
      if (isnan(x_kminus)) 
	x_kminus = 1.0/b1;
		kminus[i] = 1.0/x_kminus;}
    }
}

#endif
