#ifndef KPLUS_H
#define KPLUS_H

void update_kplus(double **y, double *mu, int **e, double *kplus,  int &Nnode, int &Nsample)
{
  int i,j,count1;
  double lower_kplus_new, upper_kplus_new, gamma_kplus_new, x_kplus, b2;
  
  for (i=0; i<Nnode; i++)
    {
      b2 = R_NegInf;
      count1 = 0;
      for (j=0; j<Nsample; j++)
	{
	  if (e[i][j]==1)
	    {
	      count1++;
	      if ((y[i][j]-mu[i])>b2) 
		b2 = y[i][j] - mu[i];
	    }
	}
      if (b2 < 0) 
	b2 = 0;
      lower_kplus_new = R_NegInf;
      upper_kplus_new = (b2 > 0) ? 1.0/b2 : R_PosInf;
      gamma_kplus_new = gamma_kplus + count1;
      x_kplus = qgamma( runif(0, pgamma(upper_kplus_new, gamma_kplus_new, 1.0/lambda_kplus, 1, 0) ), gamma_kplus_new, 1.0/lambda_kplus, 1, 0 );
		if (x_kplus!=0)
		{
      if (isnan(x_kplus)) 
	x_kplus = 1.0/b2;
		kplus[i] = 1.0/x_kplus;}
    }
}

#endif
