#ifndef MU_H
#define MU_H
void update_mu(double **y, double *sigma, int **e, double *kminus, double *kplus, double *mu,  int &Nnode, int &Nsample)

{
	
	int i,j;
	
	double sumy, counte,hat_tau_mu, hat_theta_mu, mu_lower, mu_upper, u;
	
	double c1, c2, c3;
	
	
	
	for (i=0; i<Nnode; i++)
		
	{
		
		sumy = 0;
		
		counte = 0;
		
		mu_lower = R_NegInf;
		
		mu_upper = R_PosInf;
		
		for (j=0; j<Nsample; j++)
			
		{
			
			if (e[i][j]==0) 
				
			{
				
				sumy += y[i][j];
				
				counte += 1;
				
			}
			
			if (e[i][j]==-1) 
				
			{
				
				if (y[i][j]>mu_lower) 
					
					mu_lower = y[i][j];

				
				if ((y[i][j]+kminus[i])<mu_upper)

					mu_upper = y[i][j]+kminus[i];

				
			}
			
			if (e[i][j]==1)  
				
			{ 
				
				if ((y[i][j]-kplus[i])>mu_lower) 
					
					mu_lower = y[i][j]-kplus[i];

				
				if (y[i][j]<mu_upper)
	
					mu_upper = y[i][j];

				
			}
			
			
			
		}
		
		if (mu_lower>mu_upper)
			
		{
            u = mu_lower;
			
			mu_lower = mu_upper;
			
			mu_upper = u;
			
		}
		c1 = pow(tau_mu,-2);
		c2 = pow(sigma[i],-2);
		c3 = 1.0/( c1 + counte*c2 );
		
		hat_theta_mu = ( theta_mu*c1 + sumy*c2 ) * c3;
		hat_tau_mu = pow(c3,0.5);
		
		if (mu_lower > (hat_theta_mu+5*hat_tau_mu)) 
			
			mu[i] = mu_lower;
			
		else if (mu_upper < (hat_theta_mu-5*hat_tau_mu))

			mu[i] = mu_upper;
			
		else
			
			mu[i] = qnorm( runif( pnorm(mu_lower, hat_theta_mu, hat_tau_mu, 1, 0), pnorm(mu_upper, hat_theta_mu, hat_tau_mu, 1, 0) ), hat_theta_mu, hat_tau_mu, 1, 0 );

	}
	
	
	
	
}

#endif