#ifndef SIGMA_H
#define SIGMA_H

void update_sigma(double **y, double *mu, int **e, double *sigma,  int &Nnode, int &Nsample)
{
  int i,j;
  double tmp0, tmp1, hat_gamma_sigma, hat_lambda_sigma, u;
  
  for (i=0; i<Nnode; i++)
    {
      tmp0 = 0;
      tmp1 = 0;
      for (j=0; j<Nsample; j++)
	{
	  if (e[i][j]==0) 
	    {
	      tmp0++;
	      tmp1 += pow(y[i][j]-mu[i],2);
	    }
	}
      hat_gamma_sigma = gamma_sigma + tmp0/2;
      hat_lambda_sigma = lambda_sigma + tmp1/2;
      u = rgamma(hat_gamma_sigma, 1/hat_lambda_sigma);
      sigma[i] = sqrt(1/u);
    }
  return;
}

#endif
