#ifndef Z_H
#define Z_H

void update_z(double **y, double **beta, int **graph, double *p, double *mu, double *sigma, double *kminus, double *kplus, int **z, int &Nnode, int &Nsample)
{
  int i,j,k;
  double u, ratio, tmp0, tmp1, tmp2;
  double *v;
  
  // Initialize:
  v = new double[Nnode];
  
  for (i=0; i<Nnode; i++)
    v[i] = 1/(1+exp(-beta[i][i]));
  
  for (i=0; i<Nnode; i++)
    {
      for (j=0; j<Nsample; j++)
	{
	  tmp2 = 0.0;
	  for (k=0; k<Nnode; k++)
	    {
	      if (k!=i)
		tmp2 += beta[i][k]*(1-v[i])*(z[k][j]-v[k]);
	    }
	  tmp1 = exp(beta[i][i] + tmp2) * (p[i]*dnorm(y[i][j], mu[i], sigma[i], 0) + (1-p[i])*(y[i][j]>mu[i])*(y[i][j]<(mu[i]+kplus[i]))/kplus[i]);
	  tmp2 = 0.0;
	  for (k=0; k<Nnode; k++)
	    {
	      if (k!=i)
		tmp2 += beta[i][k]*(0-v[i])*(z[k][j]-v[k]);
	    }
	  tmp0 = exp(tmp2) * (y[i][j]>(mu[i]-kminus[i]))*(y[i][j]<mu[i])/kminus[i];

	  ratio = (tmp1 == 0) ? 0 : tmp1/(tmp1+tmp0);
	  u = runif(0,1);
	  z[i][j] = (u < ratio) ? 1 : 0;
	}
    }
  
  // Delete Memory:
  delete[] v; v = NULL;	
  return;
}

#endif
